---
marp: true
---

# Terraform Training

**Safer@DayZero team**

---

# How do we use Terraform?

- Manage any infrastrcutre that lasts longer than a few hours
- Spin up/tear down

We use Terraform to manage:

- GCP
  - google work space
- Cloudflare
  - dns records
  - email routing
- Local and cloud based kubernetes depoyments
  - dyff-dev local is managed by Terraform

---

# what are we trying to do?

- Develop Terraform from your local machine
- Develop Terraform using CI

---

# When doing things locally

Local setup not required

Pros:

- Ideal for development
- Great testing
- Instant feedback
  - Do not need to wait for CI feedback

Cons:

- A lot of set-up involved

---

# When doing things in CI

CI is required

Pros:

- Less set up locally

Cons:

- Testing is slow
  - Have to wait for CI output

---

# Install Terraform

[Install Terraform 1.5.7 here](https://releases.hashicorp.com/terraform/1.5.7/)

---

# Validate that Terraform is installed

```
$ terraform version
Terraform v1.5.7
on linux_amd64
```

---

## Terraform State

- Single source of truth containing what Terraform has deployed and where.

- Must connect to a state backend.
  - GitLab
  - Local Development requires setup to talk to state backend
  - CI set up to talk to state backend

---

# Use Terrafy to connect to state backend

- Generates project skaffold
- Automatically sets up for dual deployment
- Set up state backend for local deployment

---

# Install Terrafy

Terrafy is written in Go, [install Go](https://go.dev/doc/install)

1. Go to [gitlab.com/buildgarden/tools/terrafy](https://gitlab.com/buildgarden/tools/terrafy)

2. Check out the project

3. Run:

```
    > go build
    > go install
```

---

4. Run `terrafy`:

```
    terrafy -d DEPLOYMENT [-e ENVIRONMENT ...] [-p PROVIDER ...]
  -c string
    	copyright text
  -d string
    	name of deployment
  -e value
    	name of environment
  -i	initialize project after generation
  -l string
    	license
  -p value
    	name of provider
```

---

# Layout of Terraform project

```
deploy/
    staging/
    production/
```

---

# Files generated by Terrafy

- environment directories with `main.tf` and `terraform.tf`
- `.gitignore`
- `.gitlab-ci.yml`
- `license.yaml`
- `.pre-commit-config.yaml`
- `.secrets.baseline`
- `LICENSE`
- `NOTICE`
- `locals.tf`
- `terraform.tf`
- `variables.tf`

---

# Files in environment directory

- `.terraform`
- `.treraform.locl.hcl`

---

# Create a GitLab project

---

# Clone the GitLab project

---

# Create a token in the GitLab project

- Required permissions
  - Select a role: Maintainer
  - Select scopes: api

---

# Create init.sh

Create `init.sh`

```
export GITLAB_ACCESS_TOKEN=<your-token-key>
terraform init -upgrade \
    -backend-config="username=y<your-token-user>" \
    -backend-config="password=$GITLAB_ACCESS_TOKEN"
```

---

# Run Terrafy

[Terrafy documentation](https://dsri-org.atlassian.net/wiki/spaces/SADZ/pages/60260368/Terrafy+Guide#How-to-use-Terrafy)

```
terrafy -c '2024 UL Research Institutes' -d name-of-your-repository -e production -e staging -i -l Apache-2.0
```

---

# terraform init

- `terraform init` connects local Terraform to state backend
- `terrafy` automatically does this

```
Terraform has been successfully initialized!

You may now begin working with Terraform. Try running "terraform plan" to see
any changes that are required for your infrastructure. All Terraform commands
should now work.
```

---

# Install Minikube

[Install Minikube](https://minikube.sigs.k8s.io/docs/start/)

`minikube start`

---

# Add a provider

`providers.tf`

Plugins that enable interactions with an API such as Kubernetes, GCP, AWS, Helm etc.

```
provider "kubernetes" {
  config_path    = "~/.kube/config"
  config_context = "minikube"
}
```

---

# Add terraform.tf

`terraform.tf`

```
terraform {
  required_providers {
    kubernetes = {
      source  = "hashicorp/kubernetes"
      version = "~> 2.27.0"
    }
  }
  required_version = ">=1.0"
}

```

---

# Add variables.tf

`variables.tf`

Pass values fom outside of the configuration or module

```
variable "environment" {
  type = string
}
```

---

# Add a cluster resource

Create `main.tf` and add the following resource:

```
resource "kubernetes_namespace" "example" {
  metadata {
    name = "example-namespace"
  }
}
```

` > terraform validate`
` > terraform plan`
` > terraform apply`

---

# Add another resource

```
resource "kubernetes_deployment" "example" {
  metadata {
    name = "terraform-example"
    labels = {
      test = "MyExampleApp"
    }
    namespace = "example-namespace"
  }

  spec {
    replicas = 2

    selector {
      match_labels = {
        test = "MyExampleApp"
      }
    }

    template {
      metadata {
        labels = {
          test = "MyExampleApp"
        }
      }

      spec {
        container {
          image = "nginx:1.21.6"
          name  = "example"

          resources {
            limits = {
              cpu    = "0.5"
              memory = "512Mi"
            }
            requests = {
              cpu    = "250m"
              memory = "50Mi"
            }
          }
        }
      }
    }
  }
}
```

---

# Example Terraform output

```
Terraform will perform the following actions:

  # module.root.kubernetes_namespace.example will be created
  + resource "kubernetes_namespace" "example" {
      + id                               = (known after apply)
      + wait_for_default_service_account = false

      + metadata {
          + generation       = (known after apply)
          + name             = "k8s-ns-by-tf"
          + resource_version = (known after apply)
          + uid              = (known after apply)
        }
    }

Plan: 2 to add, 0 to change, 0 to destroy.
```

---

# Terraform destroy

- `terraform destroy`
- Great cleanup

```
  # module.root.kubernetes_namespace.example will be destroyed
  - resource "kubernetes_namespace" "example" {
      - id                               = "k8s-ns-by-tf" -> null
      - wait_for_default_service_account = false -> null

      - metadata {
          - annotations      = {} -> null
          - generation       = 0 -> null
          - labels           = {} -> null
          - name             = "k8s-ns-by-tf" -> null
          - resource_version = "654" -> null
          - uid              = "de53dfb1-d041-49d6-ba4c-55be80039285" -> null
        }
    }

Plan: 0 to add, 0 to change, 2 to destroy.
```

---

# Terraform validation

` > terraform validate`
` > terraform fmt`
` > pre-commit`

[trivy](https://trivy.dev/)

---

# Run apply in CI

Commit to Git and watch CI go in GitLab

---

# Branching workflows?

Developer access or higher grants full access to state

Careful who has access

Can't use protected variables

Terraform state is managed on the honor system

Any branch can update any environment

Only give access to people you trust

---

# When not to use Terraform

- If resources change frequently
- If configuration changes in a UI is part of your daily job

---

# Further reading

- <https://brettops.io/blog/what-is-terraform/>

- <https://brettops.io/blog/bootstrapping-problem/>

- <https://brettops.io/blog/deploy-kubernetes-cluster-digitalocean-terraform-gitlab/>
